<?php

namespace SM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\SmPropostasInvestimentosService;
use SM\Traits\TResponse;

class SmPropostaInvestimentoController
{
    use TResponse;
    protected $propostaInvestimentoService;

    public function __construct(SmPropostasInvestimentosService $propostaInvestimentoService)
    {
        $this->propostaInvestimentoService = $propostaInvestimentoService;
    }

    
    public function getInvestimentoproposta(DTO\Request $request)
    {
        try {
            $data = $this->propostaInvestimentoService->getInvestimentoproposta($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    } 
    
    public function getCategorias(DTO\Request $request)
    {
        try {
            $data = $this->propostaInvestimentoService->getInvestimentoproposta($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTabFormacaoPreco(DTO\Request $request){

        try {
            $data = $this->propostaInvestimentoService->getTabFormacaoPreco($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFormacaoPreco(DTO\Request $request){

        try {
            $data = $this->propostaInvestimentoService->getFormacaoPreco($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getComposicaoInvestimento(DTO\Request $request)
    {
        try {
            $data = $this->propostaInvestimentoService->getComposicaoInvestimento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveInvestimentos(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->propostaInvestimentoService->saveInvestimentos($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    
    public function saveComposicaoInvest(DTO\Request $request)
    {
        try {
            $data = $this->propostaInvestimentoService->saveComposicaoServicos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveRelacFormInvest(DTO\Request $request)
    {
        try {
            $data = $this->propostaInvestimentoService->saveRelacFormInvest($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTabComposicoesProposta(Request $request) 
    {
        try {
            $parameters = $request->getParameters();
            $data = $this->propostaInvestimentoService->getTabComposicoesProposta($parameters);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }    

    public function saveComposicaoServicoTab(Request $request) 
    {
        try {
            $params = $request->getParameters();
            $data = $this->propostaInvestimentoService->saveComposicaoServicoTab($params);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }    

    public function getComposicoesProposta(Request $request) 
    {
        try {
            $parameters = $request->getParameters();
            $data = $this->propostaInvestimentoService->getComposicoesProposta();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }  

    public function saveTabImposto(DTO\Request $request)
    {
        try {
            $data = $this->propostaInvestimentoService->saveTabImposto($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteInvest(Request $request)
    {
        try {
            $data = $this->propostaInvestimentoService->deleteInvest($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteComposi(Request $request)
    {
        try {
            $data = $this->propostaInvestimentoService->deleteComposi($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteFormPreco(Request $request)
    {
        try {
            $data = $this->propostaInvestimentoService->deleteFormPreco($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }
}